using UnityEngine;using System.Collections;using SimpleJSON;using System.Collections.Generic;using MVR.FileManagementSecure;using System.Linq;using Battlehub.RTCommon;using System.Text.RegularExpressions;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using AssetBundles;using UnityEngine.UI;using MeshVR;using mset;using System;namespace PluginIdea.DGP{public class GrabPointData{public string uid;public Atom atom;public Vector3 beginDragLocalPos;public Vector3 endDragLocalPos;}public class DesktopClothGrabPlus : MVRScript{private List<GrabPointData> grabDatas = new List<GrabPointData>();private JSONStorableBool isShowGrabBall;private JSONStorableStringChooser grabBallChooser;private CameraHook cameraHook;private static bool IsChinease{get{return Application.systemLanguage == SystemLanguage.Chinese;}}public override void Init(){Utils.OnInitUI(CreateUIElement);SuperController.singleton.onAtomAddedHandlers += OnAtomAdded;SuperController.singleton.onAtomRemovedHandlers += OnAtomRemoved;SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;Utils.SetupInfoTextNoScroll(this, "<size=40><b>DesktopClothGrabPlus</b></size>\n\n" +                "In desktop mode, multiple control points are controlled to grab clothes at the same time.\n\n" +                 "<b>K: </b>Add a grab ball.\n\n" +                 "<b>Hold Alt + LMB click: </b>Fixed grab ball.\n\n" +                 "<b>Hold Alt: </b>Grab clothes from the target location.\n\n", 500, true);var btn = Utils.SetupButton(this, "Get More ......", () =>{if (IsChinease) Application.OpenURL(@"https:\/\/afdian.net/p/6f6685ceae9211ed8c8952540025c377");else Application.OpenURL(@"https:\/\/www.patreon.com/PluginIdea/about");}, false);btn.buttonImage.color = Color.yellow;Utils.SetupSpacer(this, 30, false);isShowGrabBall = Utils.SetupToggle(this, "Show Grab Ball", true, false);isShowGrabBall.setCallbackFunction = (val) =>{grabDatas.ForEach(a =>{a.atom.reParentObject.GetComponentInChildren<Renderer>().enabled = val;});};grabBallChooser = Utils.SetupStringChooser(this, "Chooser Current GrabBall", new List<string>(), false);grabBallChooser.setCallbackFunction = (val) =>{if (grabDatas.Count > 0){var target = grabDatas.FirstOrDefault(x => x.atom.uid == val);if(target.atom) SuperController.singleton.SelectController(target.atom.mainController);currentGrabAtom = target.atom;currentGrabPointData = new GrabPointData(){atom = currentGrabAtom, uid = currentGrabAtom.uid};}};}private void OnAtomRemoved(Atom atom){if (grabDatas.Count > 0){var target = grabDatas.First(x => x.atom == atom);if (target != null){grabDatas.Remove(target);RefreshGrabBallList();}}}private void OnPostRender(){if (isPlaced)           if(currentGrabPointData != null) GLDrawHelper.DrawLine3D(new List<GLLine3D>{new GLLine3D(){color = Color.green, from = currentGrabPointData.beginDragLocalPos, to = currentGrabPointData.endDragLocalPos}}, null);}public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false){JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);needsStore = true;if (grabDatas.Count > 0){JSONArray ballNodes = new JSONArray();grabDatas.ForEach(x =>{JSONClass grabBallNode = new JSONClass();grabBallNode["id"] = x.atom.uid;grabBallNode["beginPosX"] = x.beginDragLocalPos.x.ToString();grabBallNode["beginPosY"] = x.beginDragLocalPos.y.ToString();grabBallNode["beginPosZ"] = x.beginDragLocalPos.z.ToString();grabBallNode["endPosX"] = x.endDragLocalPos.x.ToString();grabBallNode["endPosY"] = x.endDragLocalPos.y.ToString();grabBallNode["endPosZ"] = x.endDragLocalPos.z.ToString();ballNodes.Add(grabBallNode);});jc.Add("grabBallInfos", ballNodes);}return jc;}public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true){base.RestoreFromJSON(jc, restorePhysical, restoreAppearance, presetAtoms, setMissingToDefault);grabDatas.Clear();var node = jc["grabBallInfos"] as JSONArray;if (node != null){foreach (var item in node.Childs){string uid = item["id"];float bx = float.Parse(item["beginPosX"]);float by = float.Parse(item["beginPosY"]);float bz = float.Parse(item["beginPosZ"]);float ex = float.Parse(item["endPosX"]);float ey = float.Parse(item["endPosY"]);float ez = float.Parse(item["endPosZ"]);GrabPointData grabPointData = new GrabPointData();grabPointData.uid = uid;grabPointData.beginDragLocalPos = new Vector3(bx, by, bz);grabPointData.endDragLocalPos = new Vector3(ex, ey, ez);grabDatas.Add(grabPointData);}}}private void RefreshGrabBallList(){if (grabDatas != null && grabDatas.Count > 0){var uids = grabDatas.Select(x => x.atom.uid).ToList();grabBallChooser.choices = uids;}}private void OnAtomAdded(Atom atom){if (isStartCreatingBall && atom.type == "Sphere"){isStartCreatingBall = false;CreateAGrabBall(atom);}}private Atom currentGrabAtom;private GrabPointData currentGrabPointData;private void CreateAGrabBall(Atom sphereAtom){try{sphereAtom.reParentObject.GetComponentInChildren<Renderer>().enabled = isShowGrabBall.val;sphereAtom.uid = $"grabBall_{grabDatas.Count}";var rescaleObject = sphereAtom.reParentObject.Find("object/rescaleObject");var js = sphereAtom.GetStorableByID("scale");if (js != null){js.SetFloatParamValue("scale", 0.1f);}else{rescaleObject.localScale = Vector3.one * 0.1f;}ConvertToGrabSphere(rescaleObject).enabled = false;currentGrabAtom = sphereAtom;currentGrabPointData = new GrabPointData(){atom = sphereAtom, uid = sphereAtom.uid};grabDatas.Add(currentGrabPointData);currentDragAtoms = grabDatas.Select(x => x.atom).ToList();RefreshGrabBallList();}catch (Exception e){SuperController.LogError("Exception caught: " + e);}}private GpuGrabSphere ConvertToGrabSphere(Transform rescaleObject){var sphererTrans = rescaleObject.Find("Sphere");currentGrabSphere = sphererTrans.gameObject.AddComponent<GpuGrabSphere>();currentGrabSphere.radius = 1;currentGrabSphere.GetComponent<Collider>().enabled = false;return currentGrabSphere;}private bool newGrab;private void Update(){if (Input.GetKeyDown(KeyCode.K)){CreateANewGrabSphere();}try{if (Input.GetKeyDown(KeyCode.Escape)){if (currentGrabSphere) currentGrabSphere.enabled = false;}if (Input.GetKeyDown(KeyCode.LeftAlt)){newGrab = true;isPlaced = false;if (currentGrabSphere) currentGrabSphere.enabled = true;}if (Input.GetKeyUp(KeyCode.LeftAlt)){if(!isPlaced && currentGrabSphere) currentGrabSphere.enabled = false;}if (Input.GetMouseButtonDown(0)){if (!isPlaced){isPlaced = true;if (currentGrabPointData != null && currentGrabAtom != null){currentGrabPointData.endDragLocalPos = currentGrabAtom.transform.position;}}}RefreshCurrentGrabSphere();}catch (Exception e){SuperController.LogError("Exception caught: " + e);}if (isFadeIn){timer += Time.unscaledDeltaTime;float t = Easing.Linear.EaseNone(timer, 1);grabDatas.ForEach(x =>{if (x.atom != null){x.atom.mainController.transform.position = Vector3.Lerp(x.beginDragLocalPos, x.endDragLocalPos, t);}});if (timer > 1){timer = 0;isFadeIn = false;}}}float timer, blendValue;bool isFadeIn;private List<Atom> currentDragAtoms;private void RefreshCurrentGrabSphere(){if (currentDragAtoms == null) return;var curAtom = SuperController.singleton.GetSelectedAtom();if (curAtom != null && currentDragAtoms.Contains(curAtom) && curAtom != currentGrabAtom){currentGrabAtom = curAtom;currentGrabSphere = currentGrabAtom.reParentObject.GetComponentInChildren<GpuGrabSphere>();}}private IEnumerator DelayDrag(){yield return new WaitForSeconds(0.2f);if (grabDatas.Count > 0){grabDatas.ForEach(x =>{if (x.atom != null){x.atom.mainController.transform.position = x.beginDragLocalPos;x.atom.SetOn(false);}});yield return new WaitForSeconds(.2f);grabDatas.ForEach(x =>{if (x.atom != null){x.atom.SetOn(true);}});yield return new WaitForSeconds(.3f);isFadeIn = true;}}protected int layerMask = (1 << 29) | 1;private bool isPlaced;private Vector3 localBeginPos;void FixedUpdate(){if (currentGrabAtom == null) return;try{if (currentGrabSphere.enabled){if (newGrab){RaycastHit hit = new RaycastHit();Ray r = SuperController.singleton.MonitorCenterCamera.ScreenPointToRay(Input.mousePosition);if (Physics.Raycast(r, out hit, Mathf.Infinity, layerMask)){currentGrabAtom.transform.position = hit.point;clothGrabPointScreenOffset = SuperController.singleton.MonitorCenterCamera.WorldToScreenPoint(currentGrabAtom.mainController.transform.position).z;}newGrab = false;if (currentGrabPointData != null) currentGrabPointData.beginDragLocalPos = currentGrabAtom.transform.position;}else{if (!isPlaced)                        currentGrabAtom.transform.position = SuperController.singleton.MonitorCenterCamera.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, clothGrabPointScreenOffset));}}}catch (Exception e){SuperController.LogError("Exception caught: " + e);}}private bool isStartCreatingBall;private float clothGrabPointScreenOffset;private GpuGrabSphere currentGrabSphere;private void CreateANewGrabSphere(){SuperController.singleton.AddAtomByType("Sphere", false, true, false);isStartCreatingBall = true;}private void OnDestroy(){Utils.OnDestroyUI();SuperController.singleton.onAtomAddedHandlers -= OnAtomAdded;SuperController.singleton.onAtomRemovedHandlers -= OnAtomRemoved;SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;if (grabDatas.Count > 0){grabDatas.ForEach(a =>{SuperController.singleton.RemoveAtom(a.atom);});}}private void OnSceneLoaded(){if (grabDatas.Count > 0){grabDatas.ForEach(gd =>{gd.atom = SuperController.singleton.GetAtomByUid(gd.uid);ConvertToGrabSphere(gd.atom.reParentObject.Find("object/rescaleObject"));});}RefreshGrabBallList();StartCoroutine(DelayDrag());isShowGrabBall.setCallbackFunction(isShowGrabBall.val);}}}